def with_metaclass(meta, *bases):
    """
    Helper for adding a metaclass to a class definition compatible with Python 2
    and 3.

    See Armin Ronacher's post for more information:
    http://lucumr.pocoo.org/2013/5/21/porting-to-python-3-redux/
    """
    class metaclass(meta):
        __call__ = type.__call__
        __init__ = type.__init__
        def __new__(cls, name, this_bases, d):
            if this_bases is None:
                return type.__new__(cls, name, (), d)
            return meta(name, bases, d)
    return metaclass('temporary_class', None, {})
